/*
	insieme.c
	esempi di funzioni che operano su alberi binari
	2-04-2003
*/

#include "tree.h"
#include <malloc.h>

int min(int *x, int *y){
	return *x < *y;
}

int mag(int *x, int *y){
	return *x > *y;
}
Tree insertRicerca(DATO x, Tree t){

	if(isTreeVuoto(t)) return treeCrea(x, treeVuoto(), treeVuoto());
	if(min(x, treeDato(t))) return treeCrea(treeDato(t), insertRicerca(x, treeSin(t)), treeDes(t));
	else if(mag(x, treeDato(t))) return treeCrea(treeDato(t), treeSin(t), insertRicerca(x, treeDes(t)));
	return t;
}

Tree leggiRicerca( Tree t ){
	int *x = malloc(sizeof(int));

	printf("%%");
	if(scanf("%d",x) == 1)
		return leggiRicerca(insertRicerca(x, t));
	return t;
}

static void print(int *x){
	printf("%d ", *x);
}

void stampaOrdinato(Tree t){
	if(!isTreeVuoto(t)){
		stampaOrdinato(treeSin(t));
		print(treeDato(t));
		stampaOrdinato(treeDes(t));
	}
}

/*
	ricerca: ricerca un elemento x in un albero binario t di interi.
*/

int EqDato(int *x, int y){
	return *x == y;
}

int ricerca ( Tree t , int x) {
	if ( !isTreeVuoto(t) )
		if( EqDato(treeDato(t), x) ) return 1;
		else return ricerca(treeSin(t), x) || ricerca(treeDes(t), x);
	return 0;
}

Tree unione( Tree i1, Tree i2 ) {
	if( isTreeVuoto( i1 ) ) return i2;
	if( isTreeVuoto( i2 ) ) return i1;
	
	i1 = insertRicerca( treeDato(i2), i1 );
	i1 = unione( i1, treeSin( i2 ) );
	return unione( i1, treeDes( i2 ) );
} 

//
// proposta da Matteo Nicora 
//
Tree intersezione( Tree i1, Tree i2 ) {
	if( isTreeVuoto( i1 ) || isTreeVuoto( i2 ) ) return treeVuoto();	
	if( ricerca(i2, *(int*)treeDato(i1) ) )
		return treeCrea( treeDato(i1), intersezione( treeSin(i1), i2 ),
						intersezione( treeDes(i1), i2) );
	return unione ( intersezione( treeSin(i1), i2 ), intersezione ( treeDes(i1), i2 ) );
}

int main() {

	Tree i1, i2, i, ii;
	char s[10];

	i1 = leggiRicerca( treeVuoto() );
	scanf("%c", s);
	i2 = leggiRicerca( treeVuoto() );

	stampaOrdinato( i1 );
	printf("\n\n");
	stampaOrdinato( i2 );
	printf("\n\n");
	i = unione( i1, i2 );
	printf("\n\n Unione:\n");
	stampaOrdinato( i );
	printf("\n\n intersezione:\n");
	ii = intersezione( i, i1 );
	stampaOrdinato( ii );
}